# Adding CNs

#### Function

This API is used to add CNs.

- Before calling an API, you need to understand the API in Using APIs.
- Before calling this API, obtain the required region and endpoint.

#### Constraints

- The CN growth increment ranges from 1 to 9.
- The maximum number of CNs is 256.
- If you choose the single-AZ deployment during instance creation, add CNs in the same AZ.
- The number of CNs for a DB instance must be less than or equal to twice the number of shards.

#### URI

- URI format

  POST https://{Endpoint}/opengauss/v3/{project_id}/instances/{instance_id}/action

- Example

  https://gaussdb.eu-de.otc.t-systems.com/opengauss/v3/0483b6b16e954cb88930a360d2c4e663/instances/dsfae23fsfdsae3435in01/action

- Parameter description

  Table 1 Parameter description
  Name | Mandatory | Description
  --- | --- | ---
  project_id | Yes | Specifies the project ID of a tenant in a region. For details about how to obtain the project ID, see Obtaining a Project ID.
  instance_id | Yes | Specifies the DB instance ID.

#### Request

- Parameter description

  Table 2 Parameter description
  Name | Mandatory | Type | Description
  --- | --- | --- | ---
  expand_cluster | Yes | Object | For details, see Table 3.

  Table 3 expand_cluster field data structure description
  Name | Mandatory | Type | Description
  --- | --- | --- | ---
  coordinators | Yes | Array | For details, see Table 4.

  Table 4 azCode field data structure description
  Name | Mandatory | Type | Description
  --- | --- | --- | ---
  az_code | Yes | String | Specifies the AZ to which CNs are to be added.

- Example request (adding CNs for a single-CN instance)

      {
      	"expand_cluster": {
                      "coordinators": [
                              {
                                     "az_code":"eu-de-01"
                              }
                      ]
      	}
      }

- Example request (adding CNs for a multi-CN instance)

      {
      	"expand_cluster": {
                      "coordinators": [
                              {
                                     "az_code":"eu-de-01"
                              },
                              {
                                     "az_code":"eu-de-01"
                              },
                              {
                                     "az_code":"eu-de-01"
                              }
                      ]
      	}
      }

#### Response

- Normal response

  Table 5 Parameter description
  Name | Type | Description
  --- | --- | ---
  job_id | String | Specifies the task ID.

- Example normal response

      {
      	"job_id": "2b414788a6004883a02390e2eb0ea227"
      }

- Abnormal response

  For details, see Abnormal Request Results.

#### Status Codes

For details, see Status Codes.

#### Error Codes

For details, see Error Codes.

Parent topic: DB Instance Management